/*
 * digit.c:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 * All rights reserved.
 *
 * $Log: digit.c,v $
 * Revision 1.15  2000/03/11 18:34:56  root
 * #make_checkin
 *
 * Revision 1.14  1999/11/22 04:43:40  root
 * #make_checkin
 *
 * Revision 1.13  1999/11/22 04:36:00  root
 * #make_checkin
 *
 * Revision 1.12  1999/11/21 19:48:05  root
 * #make_checkin
 *
 * Revision 1.11  1999/11/21 19:23:06  root
 * #make_checkin
 *
 * Revision 1.10  1999/11/21 05:26:48  root
 * #make_checkin
 *
 * Revision 1.9  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.8  1999/11/21 01:08:34  root
 * #make_checkin
 *
 * Revision 1.7  1999/11/20 18:47:30  root
 * #make_checkin
 *
 * Revision 1.6  1999/11/20 13:43:30  root
 * #make_checkin
 *
 * Revision 1.5  1999/11/19 00:47:39  root
 * #make_checkin
 *
 * Revision 1.4  1999/11/19 00:27:46  root
 * #make_checkin
 *
 * Revision 1.3  1999/11/19 00:26:09  root
 * #make_checkin
 *
 * Revision 1.2  1999/11/19 00:25:33  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/18 16:39:13  root
 * Initial revision
 *
 *
 */

static char rcsid[] = "$Id: digit.c,v 1.15 2000/03/11 18:34:56 root Exp root $";


#include "project.h"

#define EVENT_METHOD(i, x) GTK_WIDGET_CLASS(GTK_OBJECT(i)->klass)->x

#define XSIZE  600
#define YSIZE  400


void
instance_destructor (Instance i)
{
/*FIXME - this is woefully inadequate */

/*free digitizer resources */
  digitizer_destroy (i->dig);

/*The rest is memory */
  digit_free (i);

}

static void
digitizer_callback (gpointer ptr, gint fd, GdkInputCondition cond)
{
  Digitizer dig = (Digitizer) ptr;
  digitizer_fd_notify (dig);
}

static gint
quit_request (GtkWidget * w, GdkEvent * e, gpointer ptr)
{
  Instance i = (Instance) ptr;
  dw_quit (i->dw);
  return TRUE;
}


Instance
instanciate ()
{
GtkRequisition r;
  Instance i = CREATE_OBJ (Instance);


  i->dig = digitizer_create ();

  if (!i->dig) {
	gripe(GRIPE_WARN,"No digitizer\nFATAL\n");
	exit(1);
  }

  digitizer_ioctl (i->dig, DIG_STOP, Null);

  i->mou = mouse_create ();

  i->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (i->window, rcsid);
  gtk_window_set_title (GTK_WINDOW (i->window), rcsid);

  gtk_window_set_default_size (GTK_WINDOW (i->window),600,600);

  i->vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (i->window), i->vbox);
  gtk_widget_show (i->vbox);

  i->dr = drawing_create (i->mou, i->dig);


  i->dw = draw_window_create (i);

  gtk_box_pack_start (GTK_BOX (i->vbox), i->dw->vbox, TRUE, TRUE, 0);

  gtk_widget_show (i->dw->vbox);
  gtk_widget_show (i->vbox);

  gtk_widget_show (i->window);

  gdk_input_add (i->dig->async->fd, GDK_INPUT_READ, digitizer_callback, (gpointer) i->dig);

  digitizer_ioctl (i->dig, DIG_START, Null);


  gtk_signal_connect (GTK_OBJECT (i->window),
                      "delete-event", (GtkSignalFunc) quit_request, i);

  return i;
}

int
main (int argc, char *argv[])
{
  Instance i;
  gtk_init (&argc, &argv);
  i = instanciate ();

  gtk_main ();

  Obj_Delete (i);

  return 0;
}
