/*
 * draw_window.h:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 *
 * $Id: draw_window.h,v 1.12 2000/03/11 18:34:56 root Exp root $
 *
 * $Log: draw_window.h,v $
 * Revision 1.12  2000/03/11 18:34:56  root
 * #make_checkin
 *
 * Revision 1.11  1999/11/22 04:43:40  root
 * #make_checkin
 *
 * Revision 1.10  1999/11/22 04:36:00  root
 * #make_checkin
 *
 * Revision 1.9  1999/11/21 19:48:05  root
 * #make_checkin
 *
 * Revision 1.8  1999/11/21 19:23:06  root
 * #make_checkin
 *
 * Revision 1.7  1999/11/21 05:26:48  root
 * #make_checkin
 *
 * Revision 1.6  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.5  1999/11/21 01:08:34  root
 * #make_checkin
 *
 * Revision 1.4  1999/11/20 18:47:30  root
 * #make_checkin
 *
 * Revision 1.3  1999/11/20 13:43:30  root
 * #make_checkin
 *
 * Revision 1.2  1999/11/19 00:27:46  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/19 00:26:09  root
 * #make_checkin
 *
 *
 */

#ifndef __DRAW_WINDOW_H_        /* include guard */
#define __DRAW_WINDOW_H_

typedef struct draw_window_struct
  {

    Drawing drawing;
    int drawing_id;
    Mouse mouse;
    int digit_id;               /* Callback id from digitizer code */

    GtkWidget *vbox;
    GtkWidget *hbox;
    GtkWidget *label;
    GtkWidget *menubar;
    GtkWidget *annotation;
    GtkWidget *table;           /* Table */
    GtkWidget *hrule, *vrule;   /*Rule holders */
    GtkWidget *area;
    GdkGC *gc;

    GdkColormap *cmap;
    GdkColor red, green, blue, cyan, magenta, yellow, black, white, gray;

    Transform wt;               /*Transform from unit square to window */
    Transform vt;               /*Transform of viewport to unit square */

    Transform t;                /*Forward Xform from digitizer space to window */
    Transform it;               /*Backwards xform */

    int curs_x, curs_y, curs_on;  /*Cursor position (window coods) and visibility */

    int zooming;
    float zoom_x, zoom_y;
    int zoomb_x, zoomb_y, zoomb_w, zoomb_h;
    int zoomb_on;
    int acb_lock;

    GtkWidget *fileselector;
    GtkSignalFunc fscb;

    GtkWidget *about;


  }
 *Draw_Window;

#endif /* __DRAW_WINDOW_H_ */
