/*
 * editor.h:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 *
 * $Id: editor.h,v 1.4 1999/11/22 04:36:00 root Exp $
 *
 * $Log: editor.h,v $
 * Revision 1.4  1999/11/22 04:36:00  root
 * #make_checkin
 *
 * Revision 1.3  1999/11/21 05:26:48  root
 * #make_checkin
 *
 * Revision 1.2  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/21 01:08:34  root
 * #make_checkin
 *
 *
 */

#ifndef __EDITOR_H_             /* include guard */
#define __EDITOR_H_

typedef enum
  {
    DRAW_NEWLINE = 0,
    DRAW_LINEADD = 1,
    DRAW_LINEDONE = 2,
    DRAW_SELLINE = 3,
    DRAW_UNSELLINE = 4,
    DRAW_DELLINE = 5,
    DRAW_NEWDRAWING = 6
  }
Drawing_Event_Type;

typedef struct
  {
    Drawing_Event_Type type;
    union
      {
        Line l;
      }
    d;
  }
Drawing_Event;


struct Drawing_struct;

typedef void (*Drawing_EventProc) (struct Drawing_struct *, Drawing_Event *, void *ptr);

BEGIN_OBJECT (Drawing_Callback)
     Drawing_EventProc func;
     void *ptr;
     int id;
END_OBJECT (Drawing_Callback)

CREATOR (Drawing_Callback) = Obj_DefaultCreator;
DESTRUCTOR (Drawing_Callback) = Obj_DefaultDestructor;


BEGIN_OBJECT (Drawing)
     Digitizer d;               /*Digitizer */
     int dig_cb_id;

     Mouse m;
     int mouse_cb_id;

/*List of drawing windows to inform for redraws */

     Drawing_Callback_list callbacks;

     Line current;              /*Current line */
     Line selected;

     Line_list lines;
/*Spot_list spots; */
END_OBJECT (Drawing)

     extern void drawing_destructor (Drawing);


CREATOR (Drawing) = Obj_DefaultCreator;
DESTRUCTOR (Drawing) = drawing_destructor;


#endif /* __EDITOR_H_ */
