

/*
 * line.c:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 * All rights reserved.
 *
 * $Log: line.c,v $
 * Revision 1.7  2000/03/11 18:34:56  root
 * #make_checkin
 *
 * Revision 1.6  1999/11/22 04:43:40  root
 * #make_checkin
 *
 * Revision 1.5  1999/11/22 04:36:00  root
 * #make_checkin
 *
 * Revision 1.4  1999/11/21 05:26:48  root
 * #make_checkin
 *
 * Revision 1.3  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.2  1999/11/21 01:08:34  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/20 18:47:30  root
 * #make_checkin
 *
 *
 */

static char rcsid[] = "$Id: line.c,v 1.7 2000/03/11 18:34:56 root Exp root $";

#include "project.h"

void
line_destructor (Line l)
{
  if (l->annot)
    free (l->annot);
  if (l->l)
    free (l->l);
  digit_free (l);
}


void
line_pack (Line l)              /*Remove spare storage in line */
{
  if (l->n == l->s)
    return;

  if ((l->n) == 0)
    {
      l->s = 0;
      if (l->l)
        digit_free (l->l);
      l->l = Null;
      return;
    }

  l->s = l->n;
  l->l = digit_realloc (l->l, sizeof (Point) * l->s);
}

void
line_addpt (Line l, Point p)
{
  if (!l->l)
    {                           /*New Line */
      l->n = 0;
      l->s = DEFAULT_LINE_LENGTH;
      l->l = digit_malloc (sizeof (Point) * l->s);
    }

  if (l->n == l->s)
    {                           /*Line full */
      l->s = l->s << 1;
      l->l = digit_realloc (l->l, sizeof (Point) * l->s);
    }


  l->l[l->n] = p;
  l->n++;

}

line_write (Line l, FILE * s)
{
  int n;
  Point *p;

  magic_write (LINE_MAGIC, s);
  string_write (l->annot, s);

  int32_write (l->type, s);

  n = l->n;
  p = l->l;
  int32_write (n, s);

  while (n--)
    {

      float32_write (p->x, s);
      float32_write (p->y, s);


      p++;
    }


}

Line
line_read (FILE * s)
{
  int n;
  Point *p;
  Line l;

  if (!magic_check (LINE_MAGIC, s))
    {
      gripe (GRIPE_WARN, "line_load: wrong magic number");
      return Null;
    }

  l = CREATE_OBJ (Line);
  l->annot = string_read (s);
  l->type = int32_read (s);
  n = l->n = int32_read (s);
  p = l->l = (Point *) digit_malloc (sizeof (Point) * n);
  while (n--)
    {
      p->x = float32_read (s);
      p->y = float32_read (s);
      p++;
    }


  return l;
}
