/*
 * mouse.h:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 *
 * $Id: mouse.h,v 1.2 1999/11/21 02:56:20 root Exp $
 *
 * $Log: mouse.h,v $
 * Revision 1.2  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/21 01:08:34  root
 * #make_checkin
 *
 *
 */

#ifndef __MOUSE_H_              /* include guard */
#define __MOUSE_H_

typedef enum
  {
    MOUSE_MOTION = 1,
    MOUSE_DRAG = 2,
    MOUSE_BUTTDOWN = 3,
    MOUSE_BUTTUP = 4
  }
Mouse_Event_Type;

#define MOUSE_BUTTON(n)		(1L << (n))
#define MOUSE_BUTTONS		0xff
#define MOUSE_NUMBUTTONS	8

typedef struct
  {
    int type;
    int button;
    float x, y;
    int state;
  }
Mouse_Event;

struct mouse_struct;

typedef void (*Mouse_EventProc) (struct mouse_struct *, Mouse_Event *, void *);

BEGIN_OBJECT (Mouse_Callback)
     Mouse_EventProc func;
     void *ptr;
     int id;
END_OBJECT (Mouse_Callback)

CREATOR (Mouse_Callback) = Obj_DefaultCreator;
DESTRUCTOR (Mouse_Callback) = Obj_DefaultDestructor;



     typedef struct mouse_struct
       {
         float x, y;            /*Last known state of mouse */
         int state;

         Mouse_Callback_list callbacks;  /* Callback lists */

       }
 *Mouse;




#endif /* __MOUSE_H_ */
