


/*
 * $Log: object.c,v $
 * Revision 1.2  1999/11/19 00:33:13  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/19 00:25:33  root
 * #make_checkin
 *
 * Revision 1.1  1999/10/11 00:43:03  root
 * Initial revision
 *
 * Revision 1.3  1999/09/28 00:20:51  root
 * \#
 *
 * Revision 1.2  1999/09/28 00:18:19  root
 * \#
 *
 * Revision 1.1  1999/09/28 00:17:30  root
 * \#
 *
 * Revision 1.2  1999/09/10 11:14:01  root
 * \#
 *
 * Revision 1.1  1999/09/07 21:08:05  root
 * \#
 *
 * Revision 1.1  1998/07/31 16:59:48  root
 * makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:50  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.8  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.7  1997/06/15 23:47:49  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: object.c,v 1.2 1999/11/19 00:33:13 root Exp $";


#include <stdio.h>
#include "object.h"

void
Obj_DefaultDestructor (Object * object)
{
  if (object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid object 		Op: destruct\n");
      abort ();
    }
  digit_free (object);
  return;

}

void
Obj_DefaultCreator (Object * object)
{
}

void
Obj_CreateList (List * list)
{

  list->head = NULL;
  list->tail = NULL;

}


void
Obj_Init (Object * object)
{
  object->next = NULL;
  object->prev = NULL;
  object->destructor = Obj_DefaultDestructor;
}



void
Obj_Delete (Object * object)
{

  if (object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid object 		Op: delete\n");
      abort ();
    }
  if (((object->next) != NULL) || ((object->prev) != NULL))
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Object is still in list	Op: delete\n");
      abort ();
    }
  (*object->destructor) (object);


}



void
Obj_Remove (List * list, Object * object)
{

  if (object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid object 		Op: remove\n");
      abort ();
    }
  if (object->prev == NULL)
    {
      list->head = (Object *) object->next;
    }
  else
    {
      ((Object *) object->prev)->next = object->next;
    }

  if (object->next == NULL)
    {
      list->tail = (Object *) object->prev;
    }
  else
    {
      ((Object *) object->next)->prev = object->prev;
    }

  object->prev = NULL;
  object->next = NULL;

}


void
Obj_Insert (List * list, Object * object, int action)
{

  if (object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid object 		Op: insert\n");
      abort ();
    }
  if (((object->next) != NULL) || ((object->prev) != NULL))
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Object allready in list	Op: insert\n");
      abort ();
    }
  switch (action)
    {
    case ObjInsertHead:
      if (list->head == NULL)
        {
          object->prev = NULL;
          object->next = (caddr_t) list->head;
          list->head = object;
        }
      else
        {
          object->prev = NULL;
          object->next = (caddr_t) list->head;
          list->head->prev = (caddr_t) object;
          list->head = object;
        }
      if (list->tail == NULL)
        {
          list->tail = object;
        }
      break;
    case ObjInsertTail:
      if (list->tail == NULL)
        {
          object->next = NULL;
          object->prev = (caddr_t) list->tail;
          list->tail = object;
        }
      else
        {
          object->next = NULL;
          object->prev = (caddr_t) list->tail;
          list->tail->next = (caddr_t) object;
          list->tail = object;
        }
      if (list->head == NULL)
        {
          list->head = object;
        }
      break;
    default:
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid action 		Op: insert\n");
      abort ();
    }
}


void
Obj_InsertAfter (List * list, Object * p_object, Object * object)
{

  if (object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid object 		Op: insertafter\n");
      abort ();
    }
  if (p_object == NULL)
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Invalid p_object 		Op: insertafter\n");
      abort ();
    }
  if (((object->next) != NULL) || ((object->prev) != NULL))
    {
      fprintf (stderr, "Object package\n");
      fprintf (stderr, "Error: Object allready in list	Op: insertafter\n");
      abort ();
    }
  object->next = p_object->next;
  p_object->next = (caddr_t) object;
  object->prev = (caddr_t) p_object;


  if (object->next == NULL)
    {
      if (list->tail != p_object)
        {
          fprintf (stderr, "Object package\n");
          fprintf (stderr, "Error: Object p_object not in list	Op: insertafter\n");
          abort ();

        }
      list->tail = object;
    }
  else
    {
      Object *fish = (Object *) object->next;
      fish->prev = (caddr_t) object;
    }
}





void
Obj_DeleteList (List * list)
{
  Object *object;

  while ((object = list->head) != NULL)
    {
      Obj_Remove (list, object);
      Obj_Delete (object);
    }


}
void
Obj_ListDestructor (List * list)
{
  Obj_DeleteList (list);
  digit_free (list);
}
