





/*
 *$Log: object.h,v $
 *Revision 1.5  1999/11/21 05:26:48  root
 *#make_checkin
 *
 *Revision 1.4  1999/11/21 01:08:34  root
 *#make_checkin
 *
 *Revision 1.3  1999/11/19 00:47:39  root
 *#make_checkin
 *
 *Revision 1.2  1999/11/19 00:33:13  root
 *#make_checkin
 *
 *Revision 1.1  1999/11/19 00:26:09  root
 *#make_checkin
 *
 *Revision 1.1  1999/10/11 00:43:03  root
 *Initial revision
 *
 *Revision 1.1  1999/09/28 00:17:30  root
 *\#
 *
 *Revision 1.2  1999/09/10 11:14:01  root
 *\#
 *
 *Revision 1.1  1999/09/07 21:08:05  root
 *\#
 *
 *Revision 1.1  1998/07/31 16:59:48  root
 *makecheckin
 *
 *Revision 12.0  1998/07/31 09:58:26  root
 *\#makecheckin
 *
 *Revision 11.0  1998/05/02 23:03:44  root
 *\#makecheckin
 *
 *Revision 10.0  1997/10/22 18:33:55  root
 *\#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 *Revision 5.0  1997/07/03 15:05:48  root
 *\#makecheckin
 *
 *Revision 4.0  1997/07/01 11:58:59  root
 *\#makecheckin
 *
 *Revision 3.0  1997/06/23 12:51:50  root
 *\#makecheckin
 *
 *Revision 2.0  1997/06/23 09:04:44  root
 *\#makecheckin
 *
 *Revision 1.2  1997/06/15 23:47:49  root
 *\#makecheckin
 *
 */

#include <sys/types.h>
#include <stdlib.h>

#ifndef OBJECT_IN
#define OBJECT_IN

#define CREATOR(x) static void (*x ## _default_creator)(x)
#define DESTRUCTOR(x) static void (*x ## _default_destructor)(x)

#ifdef OBJ_NOTINALL
#ifdef OBJ_INTHIS
#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	x x ## _default_alloca(void) {\
	x res;\
	res=(x) digit_malloc(sizeof(struct x ## _struct));\
	if (!res) return((x) 0);\
	bzero((void *) res,sizeof(struct x ## _struct));\
	Obj_Init(res);\
	res->len=sizeof(struct x ## _struct);\
	res->destructor=x ## _default_destructor;\
	(*x ## _default_creator)(res);\
	return(res);\
	} \
	x ## _list x ## _list_alloca(void) {\
	x ## _list res;\
	res=(x ## _list) digit_malloc(sizeof(struct x ## _list_struct));\
	if (!res) return((x ## _list) 0);\
	Obj_Init(res);\
	res->destructor=Obj_ListDestructor;\
	Obj_CreateList(res);\
	return(res);\
	}

#else
#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	extern x x ## _default_alloca(void); \
	extern x ## _list x ## _list_alloca(void);
#endif
#else

#define BEGIN_OBJECT(x) \
	struct x ## _struct { \
	struct x ## _struct *prev;\
	struct x ## _struct *next;\
	unsigned int len;\
	void (*destructor)();
#define END_OBJECT(x)	}; \
	typedef struct x ## _struct * x;\
	typedef struct x ## _list_struct { \
	caddr_t prev;\
	caddr_t next;\
	unsigned int len;\
	void (*destructor)(struct x ## _list_struct *);\
	x head;\
	x tail;\
	} *x ## _list;\
	extern void (*x ## _default_creator)(x); \
	extern void (*x ## _default_destructor)(x); \
	static x x ## _default_alloca(void) {\
	x res;\
	res=(x) malloc(sizeof(struct x ## _struct));\
	if (!res) return((x) 0);\
	bzero((void *) res,sizeof(struct x ## _struct));\
	Obj_Init(res);\
	res->len=sizeof(struct x ## _struct);\
	res->destructor=x ## _default_destructor;\
	(*x ## _default_creator)(res);\
	return(res);\
	} \
	static x ## _list x ## _list_alloca(void) {\
	x ## _list res;\
	res=(x ## _list) malloc(sizeof(struct x ## _list_struct));\
	if (!res) return((x ## _list) 0);\
	Obj_Init(res);\
	res->destructor=Obj_ListDestructor;\
	Obj_CreateList(res);\
	return(res);\
	}


#endif


#define CREATE_OBJ(x) x ## _default_alloca()
#define CREATE_LIST(x) x ## _list_alloca()
#define OBJ_SIZE(x) sizeof(struct x ## _struct)

typedef struct
  {
    caddr_t prev;
    caddr_t next;
    unsigned int len;
    void (*destructor) ();
  }
Object;

typedef struct
  {
    caddr_t prev;
    caddr_t next;
    unsigned int len;
    void (*destructor) ();
    Object *head, *tail;
  }
List;

#define ObjInsertHead	1
#define ObjInsertTail	2

extern void Obj_DefaultDestructor ();
extern void Obj_DefaultCreator ();
extern void Obj_CreateList ();
extern void Obj_Init ();
extern void Obj_Delete ();
extern void Obj_DeleteList ();
extern void Obj_Remove ();
extern void Obj_Insert ();
extern void Obj_InsertAfter ();
extern void Obj_ListDestructor ();
#endif
