/*
 * util.c:
 *
 * Copyright (c) 1999 James McKenzie <james@fishsoup.dhs.org>.
 * All rights reserved.
 *
 * $Log: util.c,v $
 * Revision 1.9  2000/03/11 18:34:56  root
 * #make_checkin
 *
 * Revision 1.8  1999/11/22 04:43:40  root
 * #make_checkin
 *
 * Revision 1.7  1999/11/22 04:36:00  root
 * #make_checkin
 *
 * Revision 1.6  1999/11/21 02:56:20  root
 * #make_checkin
 *
 * Revision 1.5  1999/11/21 01:08:34  root
 * #make_checkin
 *
 * Revision 1.4  1999/11/20 18:47:30  root
 * #make_checkin
 *
 * Revision 1.3  1999/11/20 13:43:30  root
 * #make_checkin
 *
 * Revision 1.2  1999/11/19 00:47:39  root
 * #make_checkin
 *
 * Revision 1.1  1999/11/19 00:33:13  root
 * #make_checkin
 *
 *
 */

static char rcsid[] = "$Id: util.c,v 1.9 2000/03/11 18:34:56 root Exp root $";

#include "project.h"


GtkWidget *text_button_and_show(char *t)
{
GtkWidget *b,*w;
    b=gtk_button_new ();
    w = gtk_label_new (t);
    gtk_container_add (GTK_CONTAINER (b), w);
    gtk_widget_show(w);
    gtk_widget_show(b);

return b;
}


static void
mbdb_ok (GtkWidget * dw, gpointer ptr)
{
  int *i = (int *) ptr;
  *i=MBDB_OK;
  gtk_main_quit();
}
static void
mbdb_cancel (GtkWidget * dw, gpointer ptr)
{
  int *i = (int *) ptr;
  *i=MBDB_CANCEL;
  gtk_main_quit();
}

void stick_text_into_box_and_show(GtkBox *b,char *msg)
{
char *buf=strdup(msg);
char *sptr=buf,*eptr=buf;
GtkWidget *t,*a;


if (!buf) return;

while (*eptr) {

if (*eptr=='\n') {
*eptr=0;

t=gtk_label_new(sptr);
gtk_label_set_justify(GTK_LABEL(t),GTK_JUSTIFY_LEFT);
a=gtk_alignment_new(0.0,0.0,0.0,0.0);
gtk_container_add(GTK_CONTAINER(a),t);
gtk_widget_show(t);
gtk_box_pack_start (b,a,TRUE,TRUE,0);
gtk_widget_show(a);

sptr=eptr+1;
}
eptr++;
}

if (sptr!=eptr) {
t=gtk_label_new(sptr);
gtk_label_set_justify(GTK_LABEL(t),GTK_JUSTIFY_LEFT);
gtk_box_pack_start (b,t,TRUE,TRUE,0);
gtk_widget_show(t);
}


free(buf);



}

int modal_button_dialog_box(char *tmsg,char *tok,char *tcancel)
{
GtkWidget *d,*b;
int state=MBDB_NONE;

d=gtk_dialog_new();
gtk_window_set_title(GTK_WINDOW(d),"Warning:");

stick_text_into_box_and_show(GTK_BOX(GTK_DIALOG (d)->vbox),tmsg);

if (tok) {
    b = text_button_and_show(tok);

    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (d)->action_area),
                        b, TRUE, FALSE, 0);

    gtk_signal_connect (GTK_OBJECT (b),
                        "clicked", (GtkSignalFunc) mbdb_ok, &state);
}
if (tcancel) {

    b=text_button_and_show(tcancel);

    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (d)->action_area),
                        b, TRUE, FALSE, 0);

    gtk_signal_connect (GTK_OBJECT (b),
                        "clicked", (GtkSignalFunc) mbdb_cancel, &state);

}

  gtk_signal_connect (GTK_OBJECT (d), "delete-event",
                      GTK_SIGNAL_FUNC (gtk_true),d);

    gtk_window_set_modal(GTK_WINDOW(d),1);
    gtk_widget_show(d);

/* inner event loop */
    gtk_main();

  gtk_widget_hide(d);
  gtk_widget_destroy(d);

return state;
}

void
gripe (Gripeness g, char *fmt,...)
{

  char buf[1024];

  va_list ap;

  va_start (ap, fmt);

  vsnprintf (buf,sizeof(buf), fmt, ap);

  va_end (ap);

  buf[sizeof(buf)-1]=0;

  if (buf[strlen(buf)-1]=='\n') {
  	buf[strlen(buf)-1]=0;
  }

  switch (g)
    {
    case GRIPE_WARN:
      modal_button_dialog_box(buf,"Go Away",Null);
      break;
    case GRIPE_FATAL:
      fprintf (stderr, "FATAL: %s\n",buf);
      fprintf (stderr, "attempting coredump");
      abort ();
      exit (1);
      break;
    }
}

void *
digit_malloc (int s)
{
  void *ret = malloc (s);

  if (!ret)
    gripe (GRIPE_FATAL, "FATAL: malloc(%d) failed - attempting coredump\n", s);

  return ret;
}

void *
digit_realloc (void *p, int s)
{

  void *ret = realloc (p, s);

  if (!ret)
    gripe (GRIPE_FATAL, "FATAL: malloc(%d) failed - attempting coredump\n", s);

  return ret;

}


void
digit_free (void *p)
{
  free (p);
}

int
canreadfrom (int fd)
{

  fd_set rfds;
  struct timeval tv;

  bzero (&tv, sizeof (struct timeval));


  FD_ZERO (&rfds);
  FD_SET (fd, &rfds);

  if (!select (fd + 1, &rfds, NULL, NULL, &tv))
    return 0;

  if (!FD_ISSET (fd, &rfds))
    return 0;

  return 1;

}


void
int32_write (int i, FILE * s)
{
  BO_I_MTOF (&i, 1);
  fwrite (&i, sizeof (i), 1, s);
}

int
int32_read (FILE * s)
{
  int i;
  fread (&i, sizeof (i), 1, s);
  BO_I_FTOM (&i, 1);
  return i;
}
void
float32_write (float i, FILE * s)
{
  BO_F_MTOF (&i, 1);
  fwrite (&i, sizeof (i), 1, s);
}

float
float32_read (FILE * s)
{
  float i;
  fread (&i, sizeof (i), 1, s);
  BO_F_FTOM (&i, 1);
  return i;
}


void
magic_write (int magic, FILE * s)
{
  int32_write (magic, s);
}

int
magic_read (FILE * s)
{
  return int32_read (s);
}

int
magic_check (int magic, FILE * s)
{
  long off = ftell (s);
  int m = int32_read (s);;

  if (m == magic)
    return 1;

  fseek (s, off, SEEK_SET);

  return 0;

}

void
string_write (char *s, FILE * f)
{
  int i;

  if (!s)
    {
      int32_write (0, f);
      return;
    }

  i = strlen (s) + 1;

  int32_write (i, f);
  fwrite (s, 1, i, f);
  return;
}

char *
string_read (FILE * f)
{
  char *s = Null;
  int l;

  l = int32_read (f);

  if (!l)
    return s;

  s = digit_malloc (l);

  fread (s, 1, l, f);

  return s;
}

static gint
no_way (GtkWidget * w, GdkEvent * e, gpointer ptr)
{
  return (TRUE);
}

void
make_window_quit_proof (GtkWidget * w)
{
  gtk_signal_connect (GTK_OBJECT (w), "delete-event",
                      GTK_SIGNAL_FUNC (gtk_true),
                      GTK_WINDOW (w));


}
